diff --git a/MdeModulePkg/Include/Library/NonDiscoverableDeviceRegistrationLib.h b/MdeModulePkg/Include/Library/NonDiscoverableDeviceRegistrationLib.h
new file mode 100644
index 000000000000..5803f1c71b69
--- /dev/null
+++ b/MdeModulePkg/Include/Library/NonDiscoverableDeviceRegistrationLib.h
@@ -0,0 +1,47 @@
+/** @file
+  Copyright (c) 2016, Linaro, Ltd. All rights reserved.<BR>
+
+  This program and the accompanying materials
+  are licensed and made available under the terms and conditions of the BSD License
+  which accompanies this distribution.  The full text of the license may be found at
+  http://opensource.org/licenses/bsd-license.php
+
+  THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
+  WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+
+**/
+
+#ifndef __NON_DISCOVERABLE_DEVICE_REGISTRATION_LIB_H__
+#define __NON_DISCOVERABLE_DEVICE_REGISTRATION_LIB_H__
+
+#include <Protocol/NonDiscoverableDevice.h>
+
+/**
+  Register a non-discoverable device
+
+  @param[in]      BaseAddress     The MMIO base address of the non-discoverable
+                                  device
+  @param[in]      DeviceType      The type of non-discoverable device
+  @param[in]      DmaType         Whether the device is DMA coherent
+  @param[in]      InitFunc        Initialization routine to be invoked when the
+                                  device is enabled
+  @param[in,out]  Handle          The handle onto which to install the
+                                  non-discoverable device protocol.
+                                  If Handle is NULL or *Handle is NULL, a new
+                                  handle will be allocated.
+
+  @retval EFI_SUCCESS             The registration succeeded.
+  @retval Other                   The registration failed.
+
+**/
+EFI_STATUS
+EFIAPI
+RegisterNonDiscoverableDevice (
+  IN      EFI_PHYSICAL_ADDRESS              BaseAddress,
+  IN      NON_DISCOVERABLE_DEVICE_TYPE      DeviceType,
+  IN      NON_DISCOVERABLE_DEVICE_DMA_TYPE  DmaType,
+  IN      NON_DISCOVERABLE_DEVICE_INIT      InitFunc,
+  IN OUT  EFI_HANDLE                        *Handle OPTIONAL
+  );
+
+#endif
diff --git a/MdeModulePkg/Library/NonDiscoverableDeviceRegistrationLib/NonDiscoverableDeviceRegistrationLib.c b/MdeModulePkg/Library/NonDiscoverableDeviceRegistrationLib/NonDiscoverableDeviceRegistrationLib.c
new file mode 100644
index 000000000000..c42226a0629a
--- /dev/null
+++ b/MdeModulePkg/Library/NonDiscoverableDeviceRegistrationLib/NonDiscoverableDeviceRegistrationLib.c
@@ -0,0 +1,119 @@
+/** @file
+  Copyright (c) 2016, Linaro, Ltd. All rights reserved.<BR>
+
+  This program and the accompanying materials
+  are licensed and made available under the terms and conditions of the BSD License
+  which accompanies this distribution.  The full text of the license may be found at
+  http://opensource.org/licenses/bsd-license.php
+
+  THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
+  WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+
+**/
+
+#include <PiDxe.h>
+
+#include <Library/BaseLib.h>
+#include <Library/BaseMemoryLib.h>
+#include <Library/DevicePathLib.h>
+#include <Library/MemoryAllocationLib.h>
+#include <Library/NonDiscoverableDeviceRegistrationLib.h>
+#include <Library/UefiBootServicesTableLib.h>
+
+#include <Protocol/DevicePath.h>
+#include <Protocol/NonDiscoverableDevice.h>
+
+#pragma pack (1)
+typedef struct {
+  VENDOR_DEVICE_PATH                  Vendor;
+  UINT64                              BaseAddress;
+  EFI_DEVICE_PATH_PROTOCOL            End;
+} NON_DISCOVERABLE_DEVICE_PATH;
+
+#pragma pack ()
+
+/**
+  Register a non-discoverable device
+
+  @param[in]      BaseAddress     The MMIO base address of the platform device
+  @param[in]      DeviceType      The type of platform device
+  @param[in]      DmaType         Whether the device is DMA coherent
+  @param[in]      InitFunc        Initialization routine to be invoked when the
+                                  device is enabled
+  @param[in,out]  Handle          The handle onto which to install the platform
+                                  PCI I/O protocol has been installed.
+                                  If Handle is NULL or *Handle is NULL, a new
+                                  handle will be allocated.
+
+  @retval EFI_SUCCESS             The registration succeeded.
+  @retval other                   The registration failed.
+
+**/
+EFI_STATUS
+EFIAPI
+RegisterNonDiscoverableDevice (
+  IN      EFI_PHYSICAL_ADDRESS              BaseAddress,
+  IN      NON_DISCOVERABLE_DEVICE_TYPE      Type,
+  IN      NON_DISCOVERABLE_DEVICE_DMA_TYPE  DmaType,
+  IN      NON_DISCOVERABLE_DEVICE_INIT      InitFunc,
+  IN OUT  EFI_HANDLE                        *Handle
+  )
+{
+  NON_DISCOVERABLE_DEVICE       *Device;
+  NON_DISCOVERABLE_DEVICE_PATH  *DevicePath;
+  EFI_HANDLE                    LocalHandle;
+  EFI_STATUS                    Status;
+
+  if (Type >= NonDiscoverableDeviceTypeMax ||
+      DmaType >= NonDiscoverableDeviceDmaTypeMax) {
+    return EFI_INVALID_PARAMETER;
+  }
+
+  if (Handle == NULL) {
+    Handle = &LocalHandle;
+    LocalHandle = NULL;
+  }
+
+  Device = (NON_DISCOVERABLE_DEVICE *)AllocateZeroPool (sizeof *Device);
+  if (Device == NULL) {
+    return EFI_OUT_OF_RESOURCES;
+  }
+
+  Device->BaseAddress = BaseAddress;
+  Device->Type = Type;
+  Device->DmaType = DmaType;
+  Device->Initialize = InitFunc;
+
+  DevicePath = (NON_DISCOVERABLE_DEVICE_PATH *)CreateDeviceNode (
+                                                 HARDWARE_DEVICE_PATH,
+                                                 HW_VENDOR_DP,
+                                                 sizeof (*DevicePath));
+  if (DevicePath == NULL) {
+    Status = EFI_OUT_OF_RESOURCES;
+    goto FreeDevice;
+  }
+
+  CopyGuid (&DevicePath->Vendor.Guid, &gNonDiscoverableDeviceProtocolGuid);
+  DevicePath->BaseAddress = BaseAddress;
+
+  SetDevicePathNodeLength (&DevicePath->Vendor,
+    sizeof (*DevicePath) - sizeof (DevicePath->End));
+  SetDevicePathEndNode (&DevicePath->End);
+
+  Status = gBS->InstallMultipleProtocolInterfaces (Handle,
+                  &gNonDiscoverableDeviceProtocolGuid, Device,
+                  &gEfiDevicePathProtocolGuid, DevicePath,
+                  NULL);
+  if (EFI_ERROR (Status)) {
+    goto FreeDevicePath;
+  }
+  return EFI_SUCCESS;
+
+FreeDevicePath:
+  FreePool (DevicePath);
+
+FreeDevice:
+  FreePool (Device);
+
+  return Status;
+}
diff --git a/MdeModulePkg/Library/NonDiscoverableDeviceRegistrationLib/NonDiscoverableDeviceRegistrationLib.inf b/MdeModulePkg/Library/NonDiscoverableDeviceRegistrationLib/NonDiscoverableDeviceRegistrationLib.inf
new file mode 100644
index 000000000000..cf7792e2847c
--- /dev/null
+++ b/MdeModulePkg/Library/NonDiscoverableDeviceRegistrationLib/NonDiscoverableDeviceRegistrationLib.inf
@@ -0,0 +1,34 @@
+# @file
+# Copyright (c) 2016, Linaro, Ltd. All rights reserved.<BR>
+#
+# This program and the accompanying materials
+# are licensed and made available under the terms and conditions of the BSD License
+# which accompanies this distribution.  The full text of the license may be found at
+# http://opensource.org/licenses/bsd-license.php
+#
+# THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
+# WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+#
+
+[Defines]
+  INF_VERSION                    = 0x00010019
+  BASE_NAME                      = NonDiscoverableDeviceRegistrationLib
+  FILE_GUID                      = 8802ae41-8184-49cb-8aec-62627cd7ceb4
+  MODULE_TYPE                    = DXE_DRIVER
+  VERSION_STRING                 = 1.0
+  LIBRARY_CLASS                  = NonDiscoverableDeviceRegistrationLib
+
+[Sources]
+  NonDiscoverableDeviceRegistrationLib.c
+
+[Packages]
+  MdePkg/MdePkg.dec
+  MdeModulePkg/MdeModulePkg.dec
+
+[LibraryClasses]
+  DebugLib
+  DevicePathLib
+  UefiBootServicesTableLib
+
+[Protocols]
+  gNonDiscoverableDeviceProtocolGuid
diff --git a/MdeModulePkg/MdeModulePkg.dec b/MdeModulePkg/MdeModulePkg.dec
index 84b489d3fdb7..86685bb8b367 100644
--- a/MdeModulePkg/MdeModulePkg.dec
+++ b/MdeModulePkg/MdeModulePkg.dec
@@ -157,6 +157,10 @@ [LibraryClasses]
   ##
   FrameBufferBltLib|Include/Library/FrameBufferBltLib.h
 
+  ## @libraryclass   Provides a service to register non-discoverable device
+  ##
+  NonDiscoverableDeviceRegistrationLib|Include/Library/NonDiscoverableDeviceRegistrationLib.h
+
 [Guids]
   ## MdeModule package token space guid
   # Include/Guid/MdeModulePkgTokenSpace.h
diff --git a/MdeModulePkg/MdeModulePkg.dsc b/MdeModulePkg/MdeModulePkg.dsc
index 757d52dbede4..43421d610ede 100644
--- a/MdeModulePkg/MdeModulePkg.dsc
+++ b/MdeModulePkg/MdeModulePkg.dsc
@@ -102,6 +102,7 @@ [LibraryClasses]
   AuthVariableLib|MdeModulePkg/Library/AuthVariableLibNull/AuthVariableLibNull.inf
   VarCheckLib|MdeModulePkg/Library/VarCheckLib/VarCheckLib.inf
   FileExplorerLib|MdeModulePkg/Library/FileExplorerLib/FileExplorerLib.inf
+  NonDiscoverableDeviceRegistrationLib|MdeModulePkg/Library/NonDiscoverableDeviceRegistrationLib/NonDiscoverableDeviceRegistrationLib.inf
 
 [LibraryClasses.EBC.PEIM]
   IoLib|MdePkg/Library/PeiIoLibCpuIo/PeiIoLibCpuIo.inf
@@ -317,6 +318,7 @@ [Components]
   MdeModulePkg/Library/PeiIpmiLibIpmiPpi/PeiIpmiLibIpmiPpi.inf
   MdeModulePkg/Library/SmmIpmiLibSmmIpmiProtocol/SmmIpmiLibSmmIpmiProtocol.inf
   MdeModulePkg/Library/FrameBufferBltLib/FrameBufferBltLib.inf
+  MdeModulePkg/Library/NonDiscoverableDeviceRegistrationLib/NonDiscoverableDeviceRegistrationLib.inf
 
   MdeModulePkg/Universal/BdsDxe/BdsDxe.inf
   MdeModulePkg/Application/BootManagerMenuApp/BootManagerMenuApp.inf